#
# spec file for package cron (Version 4.1)
#
# Copyright (c) 2007 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# usedforbuild    aaa_base acl attr audit-libs autoconf automake bash bind-libs bind-utils binutils bison bzip2 coreutils cpio cpp cpp41 cracklib cvs cyrus-sasl db diffutils e2fsprogs file filesystem fillup findutils flex gawk gcc gcc41 gdbm gdbm-devel gettext gettext-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv klogd less libacl libattr libcom_err libgcc41 libltdl libmudflap41 libnscd libstdc++41 libtool libvolume_id libxcrypt libzio linux-kernel-headers m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-devel pam-modules patch perl permissions popt procinfo procps psmisc pwdutils rcs readline rpm sed strace sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel

Name:           cron
BuildRequires:  pam-devel
URL:            ftp://ftp.isc.org/isc/cron/
License:        Any permissive
Group:          System/Daemons
Requires:       smtp_daemon
Autoreqprov:    on
PreReq:         permissions
Version:        4.1
Release:        70
Summary:        cron Daemon
Source0:        vixie-%name-%version.tar.bz2
Source1:        %name.init
Source2:        run-crons
Source3:        sample.root
Source4:        deny.sample
Patch0:         vixie-%name-%version-Makefile.diff
Patch1:         vixie-%name-%version-pathnames.diff
Patch3:         vixie-%name-%version-vfork_sigchld.diff
Patch4:         vixie-%name-%version-sprintf_misc.diff
Patch5:         vixie-%name-%version-syscrondir.diff
Patch6:         vixie-%name-%version-root-allowed.diff
Patch7:         vixie-%name-%version-manpages.diff
Patch8:         vixie-%name-%version-crontab-permissions.diff
Patch9:         vixie-%name-%version-swapuids.diff
Patch10:        vixie-%name-%version-minuslog.diff
Patch11:        vixie-cron-4.1-pam.diff
Patch12:        vixie-cron-4.1-sendasuser.diff
#Patch13:        vixie-cron-4.1-stat-no-fstat.diff
Patch14:        vixie-cron-4.1-privilege_escalation.patch
Patch15:        vixie-cron-4.1-segfault.patch
Patch16:        vixie-cron-4.1-restrict_link_count.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
cron automatically starts programs at specific times. Add new entries
with "crontab -e". (See "man 5 crontab" and "man 1 crontab" for
documentation.)

Under /etc, find the directories cron.hourly, cron.daily, cron.weekly,
and cron.monthly.  Scripts and programs that are located there are
started automatically.



Authors:
--------
    Paul Vixie <paul@vix.com>

%debug_package
%prep
%setup -q -n vixie-%name-%version
%patch0 -p1
%patch1 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p0
#%patch13 -p1
%patch14 -p1
%patch15 -p0
%patch16 -p1

%build
make DEFS="$RPM_OPT_FLAGS -DWITH_PAM -Wno-comment -fpie -fstack-protector" LDFLAGS="-pie"

%install
install -d $RPM_BUILD_ROOT/usr/{bin,sbin}
install -d $RPM_BUILD_ROOT/%_mandir/man{1,5,8}
install -d $RPM_BUILD_ROOT/etc
install -d $RPM_BUILD_ROOT/etc/pam.d
make DESTDIR=$RPM_BUILD_ROOT install
install -d $RPM_BUILD_ROOT/var/spool/cron
install -d $RPM_BUILD_ROOT/var/spool/cron/tabs
install -d $RPM_BUILD_ROOT/var/spool/cron/lastrun
install -m 600 %SOURCE3 $RPM_BUILD_ROOT/etc/crontab
install -m 600 %SOURCE4 $RPM_BUILD_ROOT/etc/cron.deny
install -d $RPM_BUILD_ROOT/etc/cron.d
install -d $RPM_BUILD_ROOT/etc/cron.hourly
install -d $RPM_BUILD_ROOT/etc/cron.daily
install -d $RPM_BUILD_ROOT/etc/cron.weekly
install -d $RPM_BUILD_ROOT/etc/cron.monthly
install -d $RPM_BUILD_ROOT/usr/lib/cron
install -o root -g root -m744 %SOURCE2 $RPM_BUILD_ROOT/usr/lib/cron
install -d $RPM_BUILD_ROOT/etc/init.d
cp %SOURCE1 $RPM_BUILD_ROOT/etc/init.d/cron
chmod 744 $RPM_BUILD_ROOT/etc/init.d/cron
ln -sf ../../etc/init.d/cron $RPM_BUILD_ROOT/usr/sbin/rccron

%preun
%stop_on_removal cron

%post
%{fillup_and_insserv -psy cron CRON}
%run_permissions

%verifyscript
%verify_permissions -e /etc/crontab -e /usr/bin/crontab

%postun
%restart_on_update cron
%{insserv_cleanup}

%files
%dir %attr(700,root,root) /var/spool/cron
%dir %attr(700,root,root) /var/spool/cron/tabs
%dir /var/spool/cron/lastrun
%doc CHANGES CONVERSION FEATURES MAIL README THANKS
%config /etc/init.d/cron
%config /etc/pam.d/crond
%verify(not mode) %config(noreplace) /etc/crontab
%config(noreplace) /etc/cron.deny
%{_mandir}/man1/crontab.1.gz
%{_mandir}/man5/crontab.5.gz
%{_mandir}/man8/cron.8.gz
%verify(not mode) %attr (4750,root,trusted) /usr/bin/crontab
%attr (755,root,root) /usr/sbin/cron
/usr/sbin/rccron
/usr/lib/cron

%changelog
* Wed Apr 11 2007 - mkoenig@suse.de
- remove patch vixie-cron-4.1-stat-no-fstat.diff
  to avoid vulnerability [#95710]
* Thu Mar 29 2007 - mkoenig@suse.de
- Restrict hardlink check to avoid potential DOS attacks [#258372]
  CVE-2007-1856, SWAMP-ID 9370
* Wed Sep 27 2006 - mkoenig@suse.de
- relax requirements on crontab permissions [#207645]
* Fri Sep 01 2006 - kukuk@suse.de
- Add pam_loginuid.so to PAM config
* Wed Aug 23 2006 - mkoenig@suse.de
- fixed segfault bug [#199153]
* Mon May 29 2006 - kssingvo@suse.de
- fixed priviledge escalation bug CVE-2006-2607 (bugzilla#178863)
* Tue Mar 28 2006 - hvogel@suse.de
- really enable PAM [#160426]
* Sat Mar 11 2006 - schwab@suse.de
- Fix last change.
* Tue Feb 28 2006 - hvogel@suse.de
- add $network to Should-Start of the init script to avoid
  cron starting before network [#151141]
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 16 2006 - mmj@suse.de
- Build with -fstack-protector
* Mon Jan 16 2006 - mmj@suse.de
- Make editors which do not modify original also work [#143209]
* Mon Jan 16 2006 - mmj@suse.de
- Add the possibility to log also successful jobs, and introduce
  sysconfig variables to control this [#135619]
* Mon Jan 16 2006 - mmj@suse.de
- Send mail as user executing the cronjob [#140905]
* Sat Jan 14 2006 - schwab@suse.de
- Don't strip binaries.
* Wed Jan 11 2006 - mlasars@suse.de
- changed run-crons to run cron.daily at a designated
  time (#114761).
* Tue Dec 06 2005 - mmj@suse.de
- Make sure SELinux is disabled
* Thu Aug 25 2005 - kukuk@suse.de
- Fix permission of installed PAM config file
* Fri Jun 17 2005 - mmj@suse.de
- Compile with -fpie, link with -pie
* Wed Jun 15 2005 - mmj@suse.de
- Remove LAuS
* Thu May 12 2005 - meissner@suse.de
- use RPM_OPT_FLAGS -Wno-comment
* Wed Apr 27 2005 - mmj@suse.de
- use find -cmin instead of -ctime in run-crons [#80435]
- use /etc/cron.{allow,deny} instead of
  /var/spool/cron/{allow,deny} [#80273]
* Mon Mar 07 2005 - mmj@suse.de
- ignore .svn directories [#71052]
* Mon Mar 07 2005 - mmj@suse.de
- rm commands in /etc/crontab are redundant [#71017]
* Fri Feb 25 2005 - ro@suse.de
- explicitly set permissions for /var/spool/cron{,/tabs}
* Wed Jan 12 2005 - kukuk@suse.de
- Add PAM support
* Mon Jan 10 2005 - mmj@suse.de
- Don't source /etc/rc.status twice [#49673]
* Fri Oct 01 2004 - mmj@suse.de
- Add the old SuSE patch to be able to specify a "-" before a cron-
  tab entry and then disable logging [#45611]
* Thu Sep 30 2004 - mmj@suse.de
- Add correct permissions handling
- Fix swap_uids_back() function
* Wed Sep 22 2004 - mmj@suse.de
- Remove selinux support since it's broken at the moment [#45611]
* Tue Sep 14 2004 - mmj@suse.de
- Make run-crons up to date with laptops ac stuff [#45248]
* Tue Sep 14 2004 - ro@suse.de
- make laus stuff conditional
* Tue Aug 31 2004 - mmj@suse.de
- Remove update functionality from the last millenium
- Clean out notify mails [#44347]
- Clean up spec file a bit
* Tue Aug 31 2004 - mmj@suse.de
- Add patch to be more relaxed with permissions [#44304] [#44470]
* Wed Aug 25 2004 - thomas@suse.de
- added laus patch
* Tue Aug 24 2004 - mmj@suse.de
- New cron has slightly changed semantics, so invoke process_crontab
  correctly and make system crontabs works again
* Mon Aug 23 2004 - mmj@suse.de
- Add missing hunk to control when we reload the db
- Remove laus and laus-devel from neededforbuild for now
- Use same pathnames as before
* Mon Aug 23 2004 - mmj@suse.de
- Call make in %%build allthough make install implies it's built
* Mon Aug 23 2004 - mmj@suse.de
- Update to vixie cron 4.1:
  o Adapt many Fedora patches including what we had in our
  cron-3.0.1 patches
  o Add SELinux support
  o Add debugging info
- LAuS support for now disabled, will be enabled later
* Tue Apr 06 2004 - kukuk@suse.de
- fix permissions of crontab
* Fri Mar 26 2004 - thomas@suse.de
- cosmetic changes in spec file (inspired by mmj)
- ironed out hunk shift due to changed line offset in laus
  patch
* Wed Mar 24 2004 - thomas@suse.de
- made LAuS support work on x86_64
* Tue Mar 23 2004 - thomas@suse.de
- added LAuS patch
* Thu Oct 02 2003 - fehr@suse.de
- fix wrong nice level of cron scripts (#31961)
* Thu Sep 18 2003 - ro@suse.de
- fix typo in run-crons (#31216)
* Tue Aug 26 2003 - mmj@suse.de
- Don't do it all in the 0'th hour, but the 4th
* Sat Aug 16 2003 - kukuk@suse.de
- Modify /etc/crontab only if we need to move cron directory
- Try to restart daemon on update
* Thu Jul 03 2003 - fehr@suse.de
- fix bug in handling of monthly script in /usr/lib/cron/run-crons
  (#27704)
- adapt sigcld handling for new kernel (#26011)
* Tue May 27 2003 - sndirsch@suse.de
- /usr/lib/cron/run-crons: added missing "-n" to specify nice level
* Tue May 06 2003 - fehr@suse.de
- Fix bug in quoting patch (#26675)
* Wed Apr 16 2003 - coolo@suse.de
- use BuildRoot
* Mon Mar 24 2003 - fehr@suse.de
- Add improved version of cron_number_check.patch from Gernot Payer
* Thu Mar 20 2003 - fehr@suse.de
- Fix wrong check for number, thanks to Gernot Payer <gpayer@suse.de>
  (#25680)
* Fri Feb 28 2003 - fehr@suse.de
- Fix quoting problem with %% in crontab, thanks to Klaus G. Wagner
  <kgw@suse.de> (#17713)
* Thu Feb 13 2003 - mmj@suse.de
- Do not own /etc/cron.d* since we might want to use other cron
  versions.
* Tue Nov 05 2002 - ro@suse.de
- fixed bogus self-provides
* Tue Nov 05 2002 - ro@suse.de
- fixed typo in run-crons script (ouput->output) (#21497)
* Thu Aug 15 2002 - fehr@suse.de
- add PreReq tag to spec file
* Mon Aug 05 2002 - kukuk@suse.de
- Use $time instead of xntpd
- Make sendmail/postfix "Should-Start"
* Wed Jul 03 2002 - draht@suse.de
- crontab(1) must not leak fd for /var/spool/cron/deny and/or
  /var/spool/cron/allow to the user's editor (security).
* Thu Apr 25 2002 - fehr@suse.de
- added newline to run-cron output (#15796)
* Fri Mar 01 2002 - egmont@suselinux.hu
- fix month/day interval in manpage
* Thu Feb 21 2002 - ro@suse.de
- logger is in /bin, adapt run-crons script
* Mon Feb 04 2002 - fehr@suse.de
- fix reload option of init-script (#13026)
* Thu Jan 24 2002 - ro@suse.de
- modified fillup_and_insserv call (perl-hack not needed here)
* Fri Jan 18 2002 - ro@suse.de
- fixed initscript comments
* Thu Jan 10 2002 - ro@suse.de
- removed test for CRON variable from init script
* Wed Dec 12 2001 - fehr@suse.de
- fix wrong sigchld handling (thanks to Philip Willoughby)
- changed to new init script handling
* Fri Sep 28 2001 - ro@suse.de
- removed duplicate trap in run-crons (#11472)
* Thu Sep 13 2001 - ro@suse.de
- updated run-crons (feedback from volker_apelt, thanks)
* Fri Sep 07 2001 - schwab@suse.de
- Instead of closing std{in,out,err} redirect them to /dev/null.
* Wed Aug 15 2001 - fehr@suse.de
- add log messages when one of the /etc/cron/cron.* scripts fails
  (thanks for suggestion by Steffen Dettmer)
* Mon May 07 2001 - draht@suse.de
- Added security patch for a wrong setuid() call.
* Tue Apr 24 2001 - ro@suse.de
- added rc-link
* Mon Apr 23 2001 - ro@suse.de
- added updated startscript and rc.config variable
* Thu Apr 12 2001 - werner@suse.de
- Close stdin, stdout, and stderr on forking of the daemon.
* Wed Feb 14 2001 - fehr@suse.de
- add patch to prevent buffer overflow with usernames longer than
  19 characters
* Tue Feb 06 2001 - fehr@suse.de
- Make it compile with new glibc
- remove calls to fax utilities and texpire from default crontab
* Tue Dec 12 2000 - werner@suse.de
- Add cron.hourly because we provide /etc/cron.hourly/
- Remove lock files not at same time but with a quater offset
- Don't run *.rpmorig, *.rpmnew, *.rmpsave, *.swap, *.bak, *~, #*
- Don run a script if it is already running
- Remove `echo' to enable DTS patch of Thomas
* Fri Dec 08 2000 - fehr@suse.de
- fix bug introduced in last change
* Mon Nov 20 2000 - fehr@suse.de
- add security patch from Daniel Jacobowitz to cron
- prevent cron.daily called twice when changing from DST to normal (#998)
* Wed Nov 15 2000 - fehr@suse.de
- add most of the patches of Chris D. Faulhaber (jedgar@fxp.org) (#4249)
* Tue Sep 05 2000 - fehr@suse.de
- make sematic of cron.monthly clearer. It is now executed on the
  first check in run-crons executed in a month but at most once
  per month. Older semantic was to execute every 30 days which
  resulted in being called twice per month when month has 31 days
  and first execution was on 1st day of month. (#3850)
* Fri Jul 21 2000 - fehr@suse.de
- fix the use of ifdef __linux__ (everywhere else __linux is used)
* Wed May 31 2000 - fehr@suse.de
- Start script with "nice -15"
* Mon May 22 2000 - kukuk@suse.de
- Fix post install section
* Tue May 16 2000 - kukuk@suse.de
- Move /var/cron -> /var/spool/cron (FHS 2.1)
* Sun Feb 27 2000 - kukuk@suse.de
- Move /usr/man -> /usr/share/man
* Mon Jan 24 2000 - uli@suse.de
- added -D__linux to cope with gcc 2.95
* Thu Dec 02 1999 - bs@suse.de
- removed CDR_PROG section from run-crons. this leads to problems in
  some network environments.
* Mon Sep 20 1999 - ro@suse.de
- added Requires smtp_daemon
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Mon Aug 30 1999 - kukuk@suse.de
- always use fork instead of vfork
* Fri Aug 27 1999 - fehr@suse.de
- prevent sendmail from being called as root
* Thu Aug 26 1999 - fehr@suse.de
- fixed some possible buffer overflow exploits
* Fri Jul 23 1999 - bs@suse.de
- redirect stderr of apm call to /dev/null
* Thu Jul 15 1999 - bs@suse.de
- don't run cron jobs via run-cron if
  o  a cd writer is running
  o  laptop is AC-offline
- /etc/crontab:
  o  don't log every start of run-crons
  o  run faxclean only once a day
* Mon Mar 29 1999 - ro@suse.de
- added cron.d feature from debian-cron
* Mon Feb 01 1999 - bs@suse.de
- merged beta and stable version
- added entries in crontab to delete lastrun files, to let cronjobs be started
  at night.
* Fri Jan 08 1999 - bs@suse.de
- changed run-crons to work around finds 'strange behavior'
* Fri Dec 18 1998 - ro@suse.de
- use SIGCHLD instead of SIGCLD
* Tue Dec 15 1998 - bs@suse.de
- fixed xargs in run-crons
* Mon Dec 14 1998 - bs@suse.de
- fixed bug in run-crons
* Mon Dec 14 1998 - bs@suse.de
- added /etc/cron.* feature.
* Tue Nov 17 1998 - bs@suse.de
- added texpire to crontab.
- use noreplace for config files.
* Thu Sep 10 1998 - bs@suse.de
- fixed problem with non existing var/cron/tabs/root.
* Mon Sep 07 1998 - bs@suse.de
- fixed check for /var/cron/tabs/root in %%post section
* Mon Jul 07 1997 - florian@suse.de
- warn if cron.daily is still in /var/cron/tabs/root
- start cron.daily 10 minutes earlier, so that duplicate
  entries don't overlap :-(
* Thu Jun 05 1997 - florian@suse.de
- use /etc/crontab instead of /var/cron/tabs/root
* Fri May 16 1997 - bs@suse.de
- removed *.new -> orig stuff behavior, since is not neded for rpm.
* Wed Apr 30 1997 - florian@suse.de
- fix screen output ifrom ALLOW_FILE to DENY_FILE
- do not include syslog.c anymore, libc is fixed
- disable debugging compile time switch
- add some security patches
* Thu Feb 27 1997 - bs@suse.de
  added crontab entries for hylafax.
* Wed Jan 22 1997 - florian@suse.de
- syslogging works even if syslogd is restarted
* Thu Jan 02 1997 - bs@suse.de
- beautified man page
- store crontab.root.new in /root instead of /tmp
* Thu Jan 02 1997 - bs@suse.de
  atrun aus crontab fr root rausgenommen.
